<!-- 
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */
  -->
  
  <?php include 'createClientToken.php';?>
  
<!DOCTYPE html>

<head>
    <!-- Add meta tags for mobile and IE -->
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    
     <script src="http://code.jquery.com/jquery-1.11.1.min.js"></script>
  <link rel="stylesheet" type="text/css" href="ccf.css"/>
  
    <!-- Include the PayPal JavaScript SDK -->
    <!-- Add 'intent=authorize' if you only want to authorize the payment -->
    <!-- https://developer.paypal.com/docs/checkout/reference/customize-sdk/#disable-funding -->
    <script src="https://www.paypal.com/sdk/js?components=hosted-fields,buttons&client-id=AcNEYyp4KIYuTLS9KOsZr9Ua0Gi2c4p5dOSfSnoYTL9ZgdpNyNEvTE6LaF60Xy89BkMGFFMw4HxSb5Tf&currency=GBP&buyer-country=DE&locale=nl_NL" data-client-token='<?=$clientToken?>'></script>
  
</head>

 <!-- Set up a container element for the button -->
    <div id="paypal-button-container"></div>
    <br>

    <button value="card" id="card" class="btn" onclick="display()" style="float:left">Pay with Card</button>
    
    	<form id="my-sample-form" style='display:none'>
		<label id='card-number-label' for='card-number'>Card Number</label>
		<label id='card-type' for='card-number'></label>
		<div id='card-number' class='card_field'></div>
		
        <div style="width:49%; display: inline-block;">
        <label id='expiration-date-label' for='expiration-date'>Expiration Date</label>
        <div id='expiration-date' class='card_field'></div>
       </div>
       
       <div style="width:50%; display: inline-block; float:right">
         <label id='cvv-label' for='cvv'>CVV</label>
         <div id='cvv' class='card_field'></div>
       </div>
       
 
        <div id="payments-sdk__contingency-lightbox"></div>
       
		<button value="submit" id="submit" class="btn">Pay with Card</button>
		
	</form>
	
	
	
    <script>
        // Render the PayPal button into #paypal-button-container
        paypal.Buttons({

            // Set up the transaction
            createOrder: function(data, actions) {
                //Setup path to create order file
                return fetch('http://localhost/Sample_REST_PayPal_Commerce/createOrder.php', {
                    method: 'post'
                }).then(function(res) {
                    return res.json();
                }).then(function(data) {
                    console.log(data);
                    return data.id;
                });
            },

//             //If shipping costs change depending on the delivery address this is where you can add more vaule to the shipping costs
//             //https://developer.paypal.com/docs/checkout/integration-features/shipping-callback/
//          onShippingChange: function(data, actions){

//              console.log(data);

// 					//sGet the shipping address that they have chosen on PayPal login			
//              let shipping_address = data.shipping_address;
//              console.log(shipping_address);

// 					//Call the file in which you will calculate the new shipping costs and send the new shipping data
//             return fetch("http://localhost/Sample_REST_PayPal_Commerce/calculate_shipping.php", {
              
//              	method: "post",
//              	body: JSON.stringify({"shipping": shipping_address})
//              }).then(function(res){
            	 
//              	return res.json();
             	
//              }).then(function(data){
            	 
//              	console.log(data);
             	
             	
             
// 					  //Define the new shipping amount and add this to the total and patch the new amount to the transaction data
//                let shippingAmount = parseFloat(data.new_shipping_costs);
//                let baseOrderAmount = 90.00;
               
//                	//If needed you can restrict the countries that you wish to ship to and reject the transaction if it is within the restricted country
//                if(shipping_address.country_code === "ES"){
//                  return  actions.reject();
//                }

//                console.log("data: " + (baseOrderAmount).toFixed(2));

//                	//patch the new costs onto the transaction data   ***Hard coding values for now****
//                return actions.order.patch([
//                    {
//                        op: 'replace',
//                        path: "/purchase_units/@reference_id=='default'/amount",
//                        value: {
//                            currency_code: 'GBP',
//                            value: (baseOrderAmount + shippingAmount).toFixed(2),
//                            breakdown: {
//                                item_total: {
//                                    currency_code: 'GBP',
//                                    value: baseOrderAmount
//                                },
//                                shipping: {
//                                    currency_code: 'GBP',
//                                    value: shippingAmount
//                                }
//                            }
//                        }
//                    }
//                ]);

//              }); 
           
//            },

            // Finalize the transaction
            onApprove: function(data, actions) {
                return fetch('http://localhost/Sample_REST_PayPal_Commerce/capturePaymentForOrder.php', {
                    method: 'post'
                }).then(function(res) {
                    return res.json();
                }).then(function(details) {
                	console.log(details);

                    if(typeof details.payer === "undefined")
                    {
                    	alert("Completed");
                    }
                    else
                    {
                    	// Show a success message to the buyer
                    	alert('Transaction completed by ' + details.payer.name.given_name + '!');
                    }
                    
                    //Can get all user details from this object
                    console.log(details);
                });
            },

            onClick: function() {

            	var cardButton = document.getElementById("card");
          		var cardForm = document.getElementById('my-sample-form');

    		    cardForm.style.display="none";
    		    cardButton.style.display="block";

    		    
    	        },



        }).render('#paypal-button-container');
    </script>
    
    <script>
 // Check if card fields are eligible to render for the buyer's country. The card fields are not eligible in all countries where buyers are located.
    if (paypal.HostedFields.isEligible() === true) {
    	
      paypal.HostedFields.render({
          

        createOrder: function (data, actions) {
          return fetch('http://localhost/Sample_REST_PayPal_Commerce/createOrder.php', {
              method: 'POST'
          }).then(function(res) {
              return res.json();
          }).then(function(data) {
              return data.id;
          });
        },
        
        fields: {
            number: {
                selector: '#card-number',
                placeholder: 'Credit Card Number',
            },
            cvv: {
                selector: '#cvv',
                placeholder: 'CVV',
            },
            expirationDate: {
                selector: '#expiration-date',
                placeholder: 'MM/YYYY',
            }
        }
      }).then(hostedFields => {

          validateForm(hostedFields);

          document.querySelector('#my-sample-form').addEventListener('submit', event => {
          event.preventDefault();

          var state= hostedFields.getState();
          
          var formValid = Object.keys(state.fields).every(function (key) 
                  		  {
              				return state.fields[key].isValid; 
              			  });

			  

          if (formValid == true)
          {
              
        	  hostedFields.submit(
                	  {
                	  //Include 3d secure in transaction
                	  contingencies: ['3D_SECURE'],
                      
                  	  }).then(payload => {

                      	  //Successfull 3d secure card (5200 0000 0000 0007, EXP 01/2021, CVV 121)
                      	  //Error 3d secure card (4929 7581 9374 0191, EXP 02/2020, CVV 121)
                      	  //undefined 3d secure card (4111 1111 1111 1111, EXP 02/22, CVV 123)
                      	  
                      	  

                      	  console.log(payload);

        		  if (payload.liabilityShifted === undefined) {

            		  console.log("Liability: undefined");

            		  // ***** IMPORTANT ******
        			  //Only accept these cases if you are willing to accept the liability for the transaction, otherwise reject the transaction
        			  return fetch('http://localhost/Sample_REST_PayPal_Commerce/capturePaymentForOrder.php/' + payload.orderId, {
                          method: 'POST'
                        }).then(response => {
                          if (!response.ok) {
                            alert('Something went wrong');
                            console.log(response);
                          }
                          else
                          {
            					alert("Transaction Complete Via Card");
            					console.log(response);
                          }
                        });
                      //alert('Not enrolled for 3d secure, Please contact your bank');
                 }

                 if (payload.liabilityShifted) {
                	 console.log("Liability: shifted");
                	 return fetch('http://localhost/Sample_REST_PayPal_Commerce/capturePaymentForOrder.php/' + payload.orderId, {
                         method: 'POST'
                       }).then(response => {
                         if (!response.ok) {
                           alert('Something went wrong');
                           console.log(response);
                         }
                         else
                         {
           					alert("Transaction Complete Via Card");
           					console.log(response);
                         }
                       });
                 }

                 if (payload.authenticationReason === 'SKIPPED_BY_BUYER') {
                	 console.log("Liability: skipped");
                      alert('Please enter your 3d secure information');
                 }

                 if (!payload.liabilityShifted) {
                	 console.log("Liability: not shifted");
                      alert('Please try a different payment method or try again');
                 }


                });
          }
 
        });
      });
    }else {
        $('#my-sample-form').hide();
        }
    </script>
    
    <script>
		function validateForm(hostedFieldsInstance)
		{
			  hostedFieldsInstance.on('validityChange', function (event) {
		            var state= hostedFieldsInstance.getState();
		            //number expirationDate  cvv
		            if (event.emittedBy == "number" ){
		                
		                if (state.fields.number.isValid != true){
		                    document.getElementById("card-number-label").style.color = "Red";
		                    document.getElementById('card-number-label').innerHTML = "Invalid Card Number";
		                    document.getElementById("card-number").style.border = "1px solid Red";
		                    document.getElementById('card-type').innerHTML = "";
		                }else if (state.fields.number.isValid === true){
			                
		                    if (state.cards[0].niceType !=""){
		                        document.getElementById("card-number").style.border = "1px solid Green";
		                        document.getElementById("card-number-label").style.color = "Black";
			                    document.getElementById('card-number-label').innerHTML = "Card Number";
			                    document.getElementById('card-type').innerHTML = state.cards[0].niceType;
							    document.getElementById("card-type").style.color = "Blue";
		                    }
		                    else{
		                    	document.getElementById("card-type").style.color = "Blue";
		                    	document.getElementById("card-number").style.border = "1px solid Green";
		                        document.getElementById("card-number-label").style.color = "Black";
			                    document.getElementById('card-number-label').innerHTML = "Card Number";
		                    }
		                }
		            }
		            if (event.emittedBy == "expirationDate" ){
		                if (state.fields.expirationDate.isValid != true){
		                    document.getElementById("expiration-date-label").style.color = "Red";
		                    document.getElementById('expiration-date-label').innerHTML = "Invalid Expiration Date";
		                    document.getElementById("expiration-date").style.border = "1px solid Red";
		                }else{
		                    document.getElementById('expiration-date-label').innerHTML = "Expiration Date";
		                    document.getElementById("expiration-date-label").style.color = "black";
		                    document.getElementById("expiration-date").style.border = "1px solid Green";
		                }               
		            }
		            if (event.emittedBy == "cvv" ){
		                if(state.fields.cvv.isValid != true){
		                    document.getElementById("cvv-label").style.color = "Red";
		                    document.getElementById('cvv-label').innerHTML = "Invalid CVV";
		                    document.getElementById("cvv").style.border = "1px solid Red";
		                }else{
		                    document.getElementById('cvv-label').innerHTML = "CVV";
		                    document.getElementById("cvv-label").style.color = "Black";
		                    document.getElementById("cvv").style.border = "1px solid Green";
       
		            	}
		            }
		        });

			  //Change card type text when card type changes
			  hostedFieldsInstance.on('cardTypeChange', function (event) {
				  var state= hostedFieldsInstance.getState();
				    if (event.cards.length === 1) {
				      document.getElementById('card-type').innerHTML = state.cards[0].niceType;
				      document.getElementById("card-type").style.color = "Blue";
				    }
				    else
				    {
				    	document.getElementById('card-type').innerHTML = "";
				    }
				  });
		}
    </script>
    
    <script>
    	function display() {
    		 
    		  var cardButton = document.getElementById("card");
    
    		  var cardForm = document.getElementById('my-sample-form');
    
    			  cardForm.style.display="block";
    			  cardButton.style.display="none";
    		} 

	</script>
</body>